###############################################################################
## Dependency Manager 2.2.4
## KobazDep.tcl
## First Public Release
## 
## AUTHOR: Kobaz Mi'Daire <krobaz@yahoo.com>
## 
## REQUIRES: tcl
##
## COMMANDS: Arguments in "< >" are mandatory.
##
## require <name>
##
## DCC:
## .kbload <file> 
###############################################################################

bind dcc n kbload dcc_kbload

proc kbprovide {name} {
    global kbLoaded
    set kbLoaded($name) ""
    return
}

proc kbrequire {name} {
    global kbLoaded
    if {![info exists kbLoaded(Kobaz$name)]} {
        if {![file exists scripts/kobazscripts/Kobaz${name}.tcl]} {
            return -code error "Cannot load: Kobaz${name}.tcl! Make sure this file is in your scripts directory!"
        }
        if {[catch {uplevel #0 source scripts/kobazscripts/Kobaz${name}.tcl} error]} {
            return -code error "Cannot load: Kobaz${name}.tcl! $error"
        }
    }
}

proc kbrequiretcl {ver} {
    global tcl_version
    if {$tcl_version < $ver} {return -code error "Cannot load script, you need TCL version $ver or greater"}
}

proc dcc_kbload {handle idx arg} {
    if {$arg == ""} {
        putidx $idx "kbload usage: .kbload scriptname"
        putidx $idx "example: .kbload KobazLearn"
        return
    }

    set file [lindex $arg 0]

    if {[file exists scripts/kobazscripts/${file}.tcl]} {
	putcmdlog "#$handle# kbload $file"
        putidx $idx "kbload: Loading ${file}..."
        if {[catch {uplevel #0 source scripts/kobazscripts/${file}.tcl} error]} {return -code error "Cannot load: ${file}.tcl! $error"}
    } else {
        putidx $idx "kbload: script \"${file}.tcl\" does not exist"
    }


    return
}
